Description

Currently, Redmine offers the possibility to estimate an issue and track the time spent on that issue using the log time module.

Regarding  the progress made on an issue, the only possibility is to use the "Done ratio" field, but there are some major

disadvantages from our point of view:

1. update action requires multiple clicks

2. is not so accurate because if you calculate the remaining time using the formula "done ratio * estimated time" it means that the

remaining time can't be greater than estimated time.

Having the following scenario:

Issue with estimated time set to 4h

During the development you discover that more hours (6h for example) are required

In order to correctly register the remaining time, you need to change the estimation from 4h to 6h and let the done ratio to 0%.

Otherwise, the remaining time will be still 4h.

3. there is no relation between the log time and the done ratio field

Attached there are 2 patches:

1. 01_add_remaining_hours_field_15945.patch:

adds a new core field named "Remaining time" which behave almost like the Estimated time field

automatically set the remaining time equal with estimated time when the remaining time is null and estimated time > 0.

automatically set the remaining time to 0h when closing the issue.
2. update_issue_remaining_time.patch: the user can decide in the log time form to update or not the issue remaining hours. There

are 3 options available:

- [default] adjust automatically: issue remaining time will be decreased with the logged number of hours.

- set to x hours

- do no update remaining time.
In this way, the issue remaining time can be tracked easily.

Also, we have in plan the following improvements:

- a new option for "Done Ratio" field to be calculated using the estimated time and remaining time

- better time tracking details in the version page.

There are multiple issues related to this feature:

DoneRatio_issues_overview - Section "Requests (and patch) for adding 3rd option "Use the logged and estimated time"

#22326 (implemented by the first patch)

Related issues:

Related to Redmine - Feature #22326: New 'Remaining Time' field -- NOT relate... New

Related to Redmine - Feature #12762: Add option to calculate done ratio with ... New

Related to Redmine - Patch #1671: Show a breakdown of estimated/spent/remaini... New 2008-07-21

Related to Redmine - Patch #13400: Calculate %done based on estimated and log... New
Related to Redmine - Feature #5285: Introduce "Remaining time" column on "Iss... Closed 2010-04-09

Related to Redmine - Feature #37862: Estimated time remaining issue query column Closed

History

#1 - 2016-11-07 01:45 - Marius BĂLTEANU

Please fix the following typos in the description:

"can decide it the log time form what to updated or not the issue" -> "can decide in the log time form to update or not the issue"

"issue remaining time with be decreased" -> "issue remaining time will be decreased"

#2 - 2016-11-12 20:33 - Marius BĂLTEANU

- File 03_calculate_done_ratio_using_time.patch added

- File 04_add_remaining_time_to_version.patch added

Added last two patches on this topic.

03_calculate_done_ratio_using_time.patch

Option to calculate the done ratio based on estimated and remaining hours. If the setting "calculated from subtasks" is set, the done ratio is calculated

based on total estimated and total remaining hours.

04_add_remaining_time_to_version.patch

Add remaining time under the estimated time in version page. This info is very useful especially when you use the versions as sprints and you need to

move unfinished issues from a version to another version.

For example:

Version 1 at the beginning:  

Issue Estimated Remaining Status

1 10h 10h New

2 15h 15h New

3 15h 15h New

4 14h 14h New

Version estimated time: 54h.

Version remaining time: 54h.

At the end of the version, only Issue 1 and Issue 2 are finalized and Issue 3 and Issue 4 moved in version 2.

Version 1 at the final:  

Issue Estimated Remaining Status

1 10h 0h Closed

2 15h 0h Closed

3 15h 4h In Progress

4 14h 4h In Progress

Version estimated time: 54h.

Version remaining time: 8h.

Version 2 at the beginning:   

Issue Estimated Remaining Status

3 15h 4h In Progress

4 14h 4h In Progress

5 10h 10h New

6 10h 10h New

Version estimated time: 49h (which is the sum of initial estimations).

Version remaining time: 28h (which is the real required time to finish the version).

#3 - 2016-11-22 02:20 - Mischa The Evil
- Related to Feature #22326: New 'Remaining Time' field -- NOT related to the % done added

#4 - 2016-11-22 02:23 - Mischa The Evil

- Description updated

#5 - 2016-11-25 17:02 - Toshi MARUYAMA

- Tracker changed from Patch to Feature

#6 - 2017-03-16 17:35 - Chris Russo

+5!

#7 - 2017-03-16 18:19 - Kosta H

Marius, these patches look great! Unfortunately they don't apply cleanly to Redmine 3.3.2, 3.3.1 or to `master`. If you have a git branch and publish it,

I could help with rebasing. Would love to see this make it into core.

#8 - 2017-04-07 19:03 - Marius BĂLTEANU

Kosta H wrote:

Marius, these patches look great! Unfortunately they don't apply cleanly to Redmine 3.3.2, 3.3.1 or to `master`. If you have a git branch and

publish it, I could help with rebasing. Would love to see this make it into core.

 I'll upload a new version of the patches after the release of Redmine 3.4.0.

#9 - 2017-07-10 19:55 - Marius BĂLTEANU

- File 01_add_remaining_hours_field_3.4.1.patch added

- File 02_add_remaining_time_to_log_time_3.4.1.patch added

- File 03_calculate_done_ratio_using_time_3.4.1.patch added

- File 04_add_remaining_time_to_version_3.4.1.patch added

I've updated the patch series to apply cleanly to the latest Redmine version (3.4.1) and current trunk (r16811).

For us (Zitec) it is a very important feature, so any feedback regarding the implementation is welcome. I'll be very happy to discuss the changes

required to implement this feature in the core.

#10 - 2017-08-09 16:15 - Kosta H

Thanks so much Marius! Could the maintainers please weigh in on whether this might make it into 3.4.x or 3.5.x? I'd very much like to use these

patches on my organization's Redmine instance but am hesitant to without knowing if they'll make it into the upstream branch.

#11 - 2017-11-24 00:59 - Sudeep Halappa

This is exactly the feature I am looking for.

Apologies for the naive question. Will this feature work for Redmine 3.3.3.stable? That is the version we are currently using.

#12 - 2017-11-24 12:08 - Marius BĂLTEANU

Sudeep Halappa wrote:

This is exactly the feature I am looking for.

Apologies for the naive question. Will this feature work for Redmine 3.3.3.stable? That is the version we are currently using.

 I  didn't tests the patches against 3.3.3.stable, but you could try to apply the first version (uploaded by me in 2016).

#13 - 2017-12-13 21:20 - Anders Thomsen

+1

#14 - 2018-01-10 08:48 - Marius BĂLTEANU

- Related to Feature #12762: Add option to calculate done ratio with the data from time tracking added

#15 - 2018-02-25 17:44 - Marius BĂLTEANU
- Related to Patch #1671: Show a breakdown of estimated/spent/remaining time for a version added

#16 - 2018-06-14 23:12 - Marius BĂLTEANU

- Description updated

#17 - 2018-07-14 07:32 - Go MAEDA

- Related to Patch #13400: Calculate %done based on estimated and logged time added

#18 - 2019-06-02 04:26 - Go MAEDA

- Target version set to Candidate for next major release

#19 - 2019-12-04 09:18 - Anders Thomsen

Marius, are you still determined to have this feature added? I'm evaluating if we should should apply the patch to our own instance but will avoid if we

have to maintain it for all future versions.

If so, do you plan to provide a patch for 4.1?

#20 - 2019-12-04 09:40 - Marius BĂLTEANU

Anders Thomsen wrote:

Marius, are you still determined to have this feature added? I'm evaluating if we should should apply the patch to our own instance but will avoid

if we have to maintain it for all future versions.

 Yes, I still think that it's a good improvement for Redmine, but the decision is at Jean-Philippe.

If so, do you plan to provide a patch for 4.1?

 4.1 for sure, but I cannot say about other future versions.

#21 - 2021-01-07 11:01 - Bertrand Michas

This feature looks nice. We want to be able to say how much work it remains to close a specific version of our software. I hope this will be included in

a future Redmine release. Thank you.

#22 - 2021-08-09 13:33 - Mischa The Evil

- Related to Feature #5285: Introduce "Remaining time" column on "Issues list" page added

#23 - 2022-01-26 14:39 - Timo Hamoen

Marius BALTEANU wrote:

Anders Thomsen wrote:

Marius, are you still determined to have this feature added? I'm evaluating if we should should apply the patch to our own instance but will

avoid if we have to maintain it for all future versions.

 Yes, I still think that it's a good improvement for Redmine, but the decision is at Jean-Philippe.

If so, do you plan to provide a patch for 4.1?

 4.1 for sure, but I cannot say about other future versions.

 Is this feauture ever going to added to 4.2?

Or is there a 4.2 compatible version of the patch?

This is the only thing which is holding us back updating to 4.2 at the moment.

#24 - 2022-02-24 16:10 - pasquale [:dedalus]

+1

#25 - 2022-06-17 17:55 - Cathy Barwick

Is there any update on this ?
We need a way to know both the full time (Estimated Time) - which is best current estimate, and is used in conjunction with % done om the Agile

plugin for charts (burndown)

And the remaining time, for planning

(and somehow we also need to keep the original estimate as a "baseline" - we have this as a custom field currently)

#26 - 2022-11-07 10:02 - Go MAEDA

- Related to Feature #37862: Estimated time remaining issue query column added

#27 - 2024-05-01 03:49 - Radek Pesina

- File 01_add_remaining_hours_field_5.1.2.patch added

- File 02_add_remaining_time_to_log_time_5.1.2.patch added

- File 03_calculate_done_ratio_using_time_5.1.2.patch added

- File 04_add_remaining_time_to_version_5.1.2.patch added

Hi,

This is a feature that would be very handy to exist in Redmine! I've had a go at updating the patchsets to the latest version of Redmine (v5.1.2) - they

appear to work on my local instance of redmine.

#28 - 2024-05-01 09:57 - Marius BĂLTEANU

- Target version changed from Candidate for next major release to 6.0.0

Thanks Rakek for updating the patches. For now, I've committed #37862 in order to build on top of it this feature.

I'm thinking to make the behaviour for Estimated Remaining Time configurable from Administration with at least two options:

1. Calculated based on Estimated Time and Done Ratio (#37862)

2. Use the Remaining Estimated Time field (this issue). If this option is enabled, then we show the field in the issue and time entry pages.

What do you think?

#29 - 2024-07-04 16:00 - Zinedine BOUARICHE

Radek Pesina wrote in #note-27:

Hi,

This is a feature that would be very handy to exist in Redmine! I've had a go at updating the patchsets to the latest version of Redmine (v5.1.2) -

they appear to work on my local instance of redmine.

 Hello Radek,

i'd like to know, i don't know if you have a little amount of time to update this for 5.1.3? it could be really great! i couldn't install the 5.1.2 with bitnami

as they give only the last update on their site... i really need this functionnality and as i said could be really great if you could lend me some help!

Thanks in advance!

Cordially.

#30 - 2024-10-28 21:38 - Marius BĂLTEANU

- Target version changed from 6.0.0 to 6.1.0

Files

remaining_time_in_time_log.png 72.3 KB 2016-11-07 Marius BĂLTEANU

remaining_time_field.png 124 KB 2016-11-07 Marius BĂLTEANU

02_add_remaining_time_to_log_time_15945.patch 14.9 KB 2016-11-07 Marius BĂLTEANU

01_add_remaining_hours_field_15945.patch 43.6 KB 2016-11-07 Marius BĂLTEANU

04_add_remaining_time_to_version.patch 3.62 KB 2016-11-12 Marius BĂLTEANU

03_calculate_done_ratio_using_time.patch 4.35 KB 2016-11-12 Marius BĂLTEANU

02_add_remaining_time_to_log_time_3.4.1.patch 14.6 KB 2017-07-10 Marius BĂLTEANU

03_calculate_done_ratio_using_time_3.4.1.patch 4.43 KB 2017-07-10 Marius BĂLTEANU

01_add_remaining_hours_field_3.4.1.patch 59.1 KB 2017-07-10 Marius BĂLTEANU

04_add_remaining_time_to_version_3.4.1.patch 3.95 KB 2017-07-10 Marius BĂLTEANU
01_add_remaining_hours_field_5.1.2.patch 35.2 KB 2024-05-01 Radek Pesina

02_add_remaining_time_to_log_time_5.1.2.patch 14.4 KB 2024-05-01 Radek Pesina

03_calculate_done_ratio_using_time_5.1.2.patch 4.23 KB 2024-05-01 Radek Pesina

04_add_remaining_time_to_version_5.1.2.patch 3.73 KB 2024-05-01 Radek Pesina
